#!/usr/bin/env ruby

class Float
    alias_method :round_orig, :round
    def round(n=0)
        (self * (10.0 ** n)).round_orig * (10.0 ** (-n))
    end
end

$stderr.sync=true

$stdout.puts "Obtaining mean and standard deviation of insert sizes from SAM file."
$stdout.puts "Cancel at any time when satisfied that good estimates have been obtained."

File.open(ARGV[0]) do |f|
  sumisize=0
  sumisize2=0
  n=0
  s=""
  while(!f.eof?) do
    s=f.gets
    if s[0,1]=='@' then next end
    i = s.split("\t")[8].to_i
    if i > 0 then
      sumisize += i
      sumisize2 += i*i
      n+=1
    end
    $stderr.print "mean: #{(sumisize.to_f/n).round(2)}\tstdev: #{Math.sqrt(sumisize2/n - sumisize*sumisize/(n*n)).round(2)}\r"
    sleep 0.1 if n%10000==0 #without this, ubuntu doesn't flush
  end
end
$stderr.puts ""
